Entity = Class{}

function Entity:init(x, y, width, height, type)
    self.x = x
    self.y = y
    self.width = width
    self.height = height
    self.type = type

end

function Entity:move(spdX, spdY, dt)
    self.x = self.x + (spdX * dt)
    self.y = self.y + (spdY * dt)
end

function Entity:moveTo(x, y)
    self.x = x
    self.y = y
end

function Entity:isColliding(entities, type)
    for i = 1, #entities do
        if self:isWithin(entities[i].entity) and entities[i].entity.type == type then
            return {condit = true, it = i}
        end
    end
    return {condit = false, it = 1}
end

function Entity:isWithin(entity)
    if (((entity.x + (entity.width / 2)) >= (self.x - (self.width / 2))) 
        and ((entity.x - (entity.width / 2)) <= 
        self.x + (self.width / 2))) and (((entity.y + (entity.height / 2))
        >= (self.y - (self.height / 2)) and (entity.y - 
        (entity.height / 2)) 
        <= self.y + (self.height / 2))) then return true
    else
        return false
    end
end